# IDS

ICe Distribution Service

快速开发分布式服务器框架
<!-- PROJECT SHIELDS -->

[![Contributors][contributors-shield]][contributors-url]
[![Forks][forks-shield]][forks-url]
[![Stargazers][stars-shield]][stars-url]
[![Issues][issues-shield]][issues-url]
[![MIT License][license-shield]][license-url]
[![LinkedIn][linkedin-shield]][linkedin-url]

<!-- PROJECT LOGO -->
<br />

<p align="center">
  <a href="http://www.sencorsta.com:2203/ice/">
    <img src="http://www.sencorsta.com:7780/oos/9bbcea72b411cf0b16af4f7c1a14081c" alt="Logo" width="600" height="250">
  </a>
  
<h3 align="center">IDS</h3>
  <p align="center">
    快速开发分布式服务器框架
    <br />
    <a href="http://www.sencorsta.com:2203/ice/"><strong>探索本项目的文档 »</strong></a>
    <br />
    <br />
    <a href="http://www.sencorsta.com:2203/ice/">查看Demo</a>
    ·
    <a href="http://www.sencorsta.com:2203/ice/">报告Bug</a>
    ·
    <a href="http://www.sencorsta.com:2203/ice/">提出新特性</a>
  </p>
</p>


本篇README.md面向开发者

## 目录

- [上手指南](#上手指南)
    - [特点](#特点)
    - [适用场景](#适用场景)
    - [开发前的配置要求](#开发前的配置要求)
    - [安装步骤](#安装步骤)
    - [新项目生成方法](#新项目生成方法)
- [文件目录说明](#文件目录说明)
- [开发的架构](#开发的架构)
- [部署](#部署)
- [使用到的框架](#使用到的框架)
- [贡献者](#贡献者)
    - [如何参与开源项目](#如何参与开源项目)
- [版本说明](#版本说明)
- [版本控制](#版本控制)
- [作者](#作者)
- [鸣谢](#鸣谢)

### 上手指南

###### 特点
保持微服务理念前提下 完全不依赖中间件 一键启动 最大化节省服务器维护成本 让使用者精力集中到业务本身

麻雀虽小五脏俱全 只需要绑定一个端口 就可以实现 http websocket socket 等通讯手段 原生支持json protobuf等协议

支持静态资源访问 与vue天然结合

集成最简单数据库访问方式 用户可以无需关心数据库状态 原生支持mysql redis mongodb

低资源占用 体积小 启动快速 集成docker 一键部署
###### 适用场景
中小型网站快速开发

网络游戏服务器

手机app,小程序,公众号服务器

admin后台开发


###### 开发前的配置要求

1. **Java Development Kit (JDK)**
    - 安装 JDK 1.8 或更高版本。
    - 确保设置了正确的 JAVA_HOME 环境变量。

2. **Maven**
    - 安装 Maven 构建工具。
    - 版本要求：Maven 3.x。

3. **Lombok 插件**
    - 项目使用 Lombok，请确保 IDE 安装了 Lombok 插件，以提供注解支持。

4. **其他依赖**
    - 根据项目需要，安装并配置相关依赖。详细信息可参考项目文档或相关文档链接。


###### **安装步骤**

1. Clone the repo
```sh
git clone http://www.sencorsta.com:2203/ice/Ids.git
```
2. maven 导入pom文件

###### 新项目生成方法
1,本地更新并安装idsArchetypes
```shell
mvn clean install -f idsArchetypes/pom.xml
```
2,执行下面脚本 (执行前先修改对应的变量)
```shell
mvn archetype:generate -DarchetypeGroupId=com.sencorsta -DarchetypeArtifactId=idsArchetypes -DinteractiveMode=false -Dversion=2.0-SNAPSHOT -Dpackage=com.sencorsta.ids -DgroupId=com.sencorsta -DartifactId=SuperMarioGame
```

### 文件目录说明


```plaintext
.
├── src/
│   ├── main/
│   │   ├── java/
│   │   │   └── com/
│   │   │       └── example/
│   │   │           └── Main.java
│   │   └── resources/
│   │       ├── application.properties
│   │       └── ...
│   └── test/
│       ├── java/
│       │   └── com/
│       │       └── example/
│       │           └── MainTest.java
│       └── resources/
│           └── ...
├── target/
│   └── ...
├── Dockerfile
├── README.md
└── pom.xml

```

* src/main/java: 主要源代码目录。
* src/main/resources: 主要资源文件目录。
* src/test/java: 测试源代码目录。
* src/test/resources: 测试资源文件目录。
* target: 构建输出目录。
* Dockerfile: Docker 镜像构建文件。
* README.md: 项目文档。



### 开发的架构

![image](http://www.sencorsta.com:2401/oss/ids/mind.png)

### 部署

支持Dockerfile一键部署

### 使用到的框架

- [netty](https://netty.io)
- [jackson](https://github.com/FasterXML/jackson)
- [redisson](https://redisson.org)
- [hutool](https://hutool.cn)

### 贡献者

请阅读**CONTRIBUTING.md** 查阅为该项目做出贡献的开发者。

#### 如何参与开源项目

贡献使开源社区成为一个学习、激励和创造的绝佳场所。你所作的任何贡献都是**非常感谢**的。


1. Fork the Project
2. Create your Feature Branch (`git checkout -b feature/AmazingFeature`)
3. Commit your Changes (`git commit -m 'Add some AmazingFeature'`)
4. Push to the Branch (`git push origin feature/AmazingFeature`)
5. Open a Pull Request


### 版本说明
ids1.0系列最高版本号v1.6.21 目前已经停止维护

ids2.0系列是船新重构版本 目前处于开发阶段....

### 版本控制

该项目使用Git进行版本管理。您可以在repository参看当前可用版本。

### 作者

ice

Email: icemaker88@gmail.com

知乎:ice  &ensp; qq:123709547

*您也可以在贡献者名单中参看所有参与该项目的开发者。*

### 版权说明

该项目签署了MIT 授权许可，详情请参阅 [LICENSE.txt](https://github.com/shaojintian/Best_README_template/blob/master/LICENSE.txt)

### 鸣谢


- [GitHub Emoji Cheat Sheet](https://www.webpagefx.com/tools/emoji-cheat-sheet)
- [Img Shields](https://shields.io)
- [Choose an Open Source License](https://choosealicense.com)
- [GitHub Pages](https://pages.github.com)
- [Animate.css](https://daneden.github.io/animate.css)

<!-- links -->
[your-project-path]:shaojintian/Best_README_template
[contributors-shield]: https://img.shields.io/github/contributors/shaojintian/Best_README_template.svg?style=flat-square
[contributors-url]: https://github.com/shaojintian/Best_README_template/graphs/contributors
[forks-shield]: https://img.shields.io/github/forks/shaojintian/Best_README_template.svg?style=flat-square
[forks-url]: https://github.com/shaojintian/Best_README_template/network/members
[stars-shield]: https://img.shields.io/github/stars/shaojintian/Best_README_template.svg?style=flat-square
[stars-url]: https://github.com/shaojintian/Best_README_template/stargazers
[issues-shield]: https://img.shields.io/github/issues/shaojintian/Best_README_template.svg?style=flat-square
[issues-url]: https://img.shields.io/github/issues/shaojintian/Best_README_template.svg
[license-shield]: https://img.shields.io/github/license/shaojintian/Best_README_template.svg?style=flat-square
[license-url]: https://github.com/shaojintian/Best_README_template/blob/master/LICENSE.txt
[linkedin-shield]: https://img.shields.io/badge/-LinkedIn-black.svg?style=flat-square&logo=linkedin&colorB=555
[linkedin-url]: https://linkedin.com/in/shaojintian