package com.sencorsta.ids.api.tools;

import com.fasterxml.jackson.core.type.TypeReference;
import com.sencorsta.ids.api.request.ReqUserVerify;
import com.sencorsta.ids.api.response.ResUserVerify;
import com.sencorsta.ids.core.application.proxy.ProxyClient;
import com.sencorsta.ids.core.constant.ProtocolTypeConstant;
import com.sencorsta.ids.core.constant.SerializeTypeConstant;
import com.sencorsta.ids.core.entity.IdsResponse;
import com.sencorsta.ids.core.net.protocol.RpcMessage;
import com.sencorsta.utils.object.Jsons;

/**
 * 用户服务请求工具
 *
 * @author daibin
 */
public class UserReqTools {
    public static IdsResponse<ResUserVerify> verify(String userId, ReqUserVerify data) {
        RpcMessage message = new RpcMessage(ProtocolTypeConstant.TYPE_RPC_REQ);
        message.setUserId(userId);
        message.setMethod("/user/verify");
        message.setSerializeType(SerializeTypeConstant.TYPE_JSON);
        message.setData(Jsons.serializeBytes(data));
        RpcMessage resSync = ProxyClient.requestByTypeSync(message, "idsUser");
        if (resSync == null) {
            return null;
        }
        return Jsons.toBean(resSync.getData(), new TypeReference<IdsResponse<ResUserVerify>>() {});
    }
}
