package com.sencorsta.ids.bean.table;

import com.sencorsta.ids.core.database.mongo.BaseEntity;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;

/**
 * 文件字典
 *
 * @author daibin
 */
@Data
@NoArgsConstructor
@AllArgsConstructor
public class FileDictionary extends BaseEntity {
    String userId;
    /**
     * 文件唯一ID
     */
    String uuid;
    /**
     * 文件相对路径
     */
    String path;
    /**
     * 原文件名(用户定义)
     */
    String fileName;

    /**
     * 物理地址(不对外 关联数据库就行)
     */
    String physicalAddress;
    /**
     * 用户可以通过/oss/md5来访问资源
     */
    String md5;

    /**
     * 是否公开
     */
    boolean isPublic;
}
