package com.sencorsta.ids.core.constant;

/**
 * @author ICe
 */
public class ProtocolTypeConstant {
    /**
     * 远程调用请求 比如 客户端-(REQ或者http)->gate(业务显式请求)-(RPC_REQ)->user
     */
    public static final short TYPE_RPC_REQ = 1;

    /**
     * 远程调用响应 比如 user-(RPC_RES)->gate(业务显式返回)-(RES或者http)->客户端
     */
    public static final short TYPE_RPC_RES = 2;

    /**
     * 客户端的请求 比如 客户端-(REQ)->gate(本地处理)
     */
    public static final short TYPE_REQ = 3;
    /**
     * 客户端的请求 比如 gate(本地处理)-(RES)->客户端
     */
    public static final short TYPE_RES = 4;

    /**
     * 客户端的心跳 客户端-(HEAT)->gate(本地处理)
     */
    public static final short TYPE_HEAT = 5;

    /**
     * 客户端的推送 比如 gate(本地处理)-(PUSH)->客户端
     */
    public static final short TYPE_PUSH = 6;

    /**
     * 远程调用推送 比如 user-(RPC_PUSH)->gate(业务显式返回)
     */
    public static final short TYPE_RPC_PUSH = 7;

    /**
     * 代理请求 比如 客户端-(REQ或者http)->gate(自动转发)-(PROXY_REQ)->user
     */
    public static final short TYPE_PROXY_REQ = 9;
    /**
     * 代理响应 比如 user-(PROXY_RES)->gate(自动转发)-(RES或者http)->客户端
     */
    public static final short TYPE_PROXY_RES = 10;
    /**
     * 代理推送 比如 user-(PROXY_PUSH)->gate(自动转发)-(TYPE_PUSH)->客户端
     * 推送不能用于http请求
     */
    public static final short TYPE_PROXY_PUSH = 11;

    /**
     * 代理请求http方式 比如 客户端-(REQ或者http)->gate(自动转发)-(PROXY_REQ)->user
     */
    public static final short TYPE_PROXY_HTTP_REQ = 12;
    /**
     * 代理响应http方式 比如 user-(PROXY_RES)->gate(自动转发)-(RES或者http)->客户端
     */
    public static final short TYPE_PROXY_HTTP_RES = 13;


    public static String getProtocolStrByType(int type) {
        switch (type) {
            case TYPE_RPC_REQ:
                return "RPC_REQ";
            case TYPE_RPC_RES:
                return "RPC_RES";
            case TYPE_REQ:
                return "REQ";
            case TYPE_RES:
                return "RES";
            case TYPE_HEAT:
                return "HEAT";
            case TYPE_PUSH:
                return "PUSH";
            case TYPE_RPC_PUSH:
                return "RPC_PUSH";
            case TYPE_PROXY_REQ:
                return "PROXY_REQ";
            case TYPE_PROXY_RES:
                return "PROXY_RES";
            case TYPE_PROXY_PUSH:
                return "PROXY_PUSH";
            case TYPE_PROXY_HTTP_REQ:
                return "PROXY_HTTP_REQ";
            case TYPE_PROXY_HTTP_RES:
                return "PROXY_HTTP_RES";
            default:
                return "UNKNOWN";
        }
    }
}
