package com.sencorsta.utils.number;

/**
 * @author daibin
 */
public class Numbers {
    /**
     * 找到long强转int后的第round倍的原来的long值
     * @param res32num 强转后的值
     * @param isPositive 原来的long值的符号 true为正 false为负
     * @param round 0是未溢出 1是至少一倍溢出 以此类推
     * @return 结果
     */
    public static long findOverSrc64Num(int res32num, boolean isPositive, int round) {
        if (round <= 0) {
            throw new RuntimeException("round至少为1");
        }
        boolean isResPositive = res32num >= 0;
        if (!isResPositive) {
            return -findOverSrc64Num(-res32num, !isPositive, round);
        }
        long src64Num;
        if (isPositive) {
            long mask = ((long) round << 32);
            src64Num = res32num | mask;
        } else {
            long mask = ((long) -round << 32);
            src64Num = res32num | mask;
        }
        return src64Num;
    }
}
