package com.sencorsta.idsoos.dao;

import cn.hutool.core.util.ReUtil;
import com.mongodb.client.model.Filters;
import com.sencorsta.ids.bean.table.FileDictionary;
import com.sencorsta.ids.core.database.mongo.MongoTemplate;
import com.sencorsta.ids.core.entity.annotation.Repository;
import com.sencorsta.idsoos.IdsOos;
import org.bson.conversions.Bson;

import java.util.ArrayList;
import java.util.List;

/**
 * @author ICe
 */
@Repository
public class IdsOosDao {
    private MongoTemplate mongoOos = IdsOos.getMongoOOS();

    public void insertNewFile(FileDictionary fileDictionary) {
        mongoOos.insertOneTable(fileDictionary);

    }

    public List<FileDictionary> findFiles(String userId, String fileName, String uuid, String path) {
        // 构造基本的过滤条件，确保 userId 一致
        Bson filter = Filters.eq("userId", userId);

        // 如果 uuid 不为空，则直接根据 uuid 进行过滤
        if (uuid != null && !uuid.isEmpty()) {
            filter = Filters.and(filter, Filters.eq("uuid", uuid));
        } else {
            // 如果 uuid 为空，则使用 AND 关系构造 fileName 和 path 的过滤条件
            // 模糊搜索，不区分大小写
            Bson fileNameFilter = Filters.regex("fileName", fileName == null ? ".*" : ReUtil.escape(fileName), "i");
            // 模糊搜索，不区分大小写
            Bson pathFilter = Filters.regex("path", path == null ? ".*" : ReUtil.escape(path), "i");

            // 使用 AND 关系连接过滤条件
            filter = Filters.and(filter, fileNameFilter, pathFilter);
        }

        return mongoOos.findAll("FileDictionary", filter, FileDictionary.class);
    }
}
