package com.sencorsta.ids.idsuser;

import cn.hutool.core.util.StrUtil;
import com.sencorsta.ids.core.application.Application;
import com.sencorsta.ids.core.config.ConfigGroup;
import com.sencorsta.ids.core.config.GlobalConfig;
import com.sencorsta.ids.core.database.mongo.MongoConfig;
import com.sencorsta.ids.core.database.mongo.MongoTemplate;
import lombok.Getter;


/**
 * @author ICe
 */
public class IdsUser extends Application {
    @Getter
    public static MongoTemplate mongoUser;


    public static IdsUser init() {
        instance = new IdsUser();


        Boolean enableMongo = GlobalConfig.instance().getBool("enable", ConfigGroup.mongo.getName(), false);
        if (enableMongo) {
            String url = GlobalConfig.instance().getStr("url", ConfigGroup.mongo.getName(), "");
            if (StrUtil.isBlank(url)) {
                throw new RuntimeException("启用了mongo 但是缺少配置: url:" + url);
            }
            mongoUser = new MongoTemplate(new MongoConfig(url, "user"));
        }

        return (IdsUser) instance;
    }
}
