package com.sencorsta.ids.idsuser.controller;

import com.sencorsta.ids.api.request.ReqUserLoginAccount;
import com.sencorsta.ids.api.request.ReqUserRegister;
import com.sencorsta.ids.api.request.ReqUserVerify;
import com.sencorsta.ids.api.response.ResUserLoginAccount;
import com.sencorsta.ids.api.response.ResUserRegister;
import com.sencorsta.ids.api.response.ResUserVerify;
import com.sencorsta.ids.core.entity.IdsRequest;
import com.sencorsta.ids.core.entity.IdsResponse;
import com.sencorsta.ids.core.entity.annotation.Autowired;
import com.sencorsta.ids.core.entity.annotation.Controller;
import com.sencorsta.ids.core.entity.annotation.RequestMapping;
import com.sencorsta.ids.idsuser.service.UserService;
import lombok.RequiredArgsConstructor;
import lombok.extern.slf4j.Slf4j;

/**
 * @author ICe
 */
@Controller
@RequestMapping("/user")
@Slf4j
@RequiredArgsConstructor(onConstructor = @__(@Autowired))
public class IdsUserController {

    private final UserService userService;

    @RequestMapping("/loginAccount")
    public IdsResponse<ResUserLoginAccount> loginAccount(IdsRequest<ReqUserLoginAccount> request) {
        return userService.loginAccount(request);
    }


    @RequestMapping("/register")
    public IdsResponse<ResUserRegister> register(IdsRequest<ReqUserRegister> request) {
        return userService.register(request);
    }

    @RequestMapping("/verify")
    public IdsResponse<ResUserVerify> verify(IdsRequest<ReqUserVerify> request) {
        return userService.verify(request);
    }
}
