package com.sencorsta.ids.idsuser.dao;

import com.mongodb.client.model.Filters;
import com.sencorsta.ids.bean.table.Account;
import com.sencorsta.ids.core.database.mongo.MongoTemplate;
import com.sencorsta.ids.core.entity.annotation.Repository;
import com.sencorsta.ids.idsuser.IdsUser;
import org.bson.conversions.Bson;

/**
 * @author ICe
 */
@Repository
public class UserDao {
    private MongoTemplate mongoUser = IdsUser.getMongoUser();

    public Account findByAccount(String account) {
        // 创建 $or 查询条件
        Bson orFilter = Filters.eq("account", account);
        return mongoUser.findOneTable(orFilter, Account.class);
    }

    public Account findByAccountOrEmailOrPhone(String account, String email, String phone) {
        // 创建 $or 查询条件
        Bson orFilter = Filters.or(
                Filters.eq("account", account),
                Filters.eq("email", email),
                Filters.eq("phone", phone)
        );
        return mongoUser.findOneTable(orFilter, Account.class);
    }

    public void insertAccount(Account accountBean) {
        mongoUser.insertOneTable(accountBean);
    }
}
