package com.sencorsta.ids.idsuser.service;


import com.sencorsta.ids.api.request.ReqUserLoginAccount;
import com.sencorsta.ids.api.request.ReqUserRegister;
import com.sencorsta.ids.api.request.ReqUserVerify;
import com.sencorsta.ids.api.response.ResUserLoginAccount;
import com.sencorsta.ids.api.response.ResUserRegister;
import com.sencorsta.ids.api.response.ResUserVerify;
import com.sencorsta.ids.core.entity.IdsRequest;
import com.sencorsta.ids.core.entity.IdsResponse;

/**
 * @author ICe
 */
public interface UserService {
    /**
     * 登录
     * @param request 请求
     * @return ResUserLoginAccount 响应
     */
    IdsResponse<ResUserLoginAccount> loginAccount(IdsRequest<ReqUserLoginAccount> request);

    /**
     * 注册
     * @param request 请求
     * @return ResUserRegister 响应
     */
    IdsResponse<ResUserRegister> register(IdsRequest<ReqUserRegister> request);

    /**
     * 验证
     * @param request 请求
     * @return 响应
     */
    IdsResponse<ResUserVerify> verify(IdsRequest<ReqUserVerify> request);
}
