package com.sencorsta.model;

import com.sencorsta.constance.HumanConstant;
import com.sencorsta.utils.RollDice;
import lombok.Data;

/**
 *
 */
@Data
public class Human {
    int baseAtk = 10;

    /**
     * 年龄 每次生日增加
     */
    int age;
    /**
     * 命理 决定生老病死
     */
    int numerology;
    /**
     * 命理buff 越高越长寿
     */
    int numerologyBuff;

    /**
     * 成熟度 未满有减益 超过也有减益
     */
    int mature;
    /**
     * 成熟度 越高越早熟
     */
    int matureBuff;
    /**
     * 成熟期 越高越同意保持状态
     */
    int matureTimeBuff;


    public void nextYear() {
        age++;
        numerology += RollDice.rollDices(age - numerologyBuff, 1);
        mature += RollDice.rollDices(age + matureBuff, 1);
    }

    public int getBuffMature() {
        if (mature < HumanConstant.MATURE) {
            return -(HumanConstant.MATURE - mature) * 2 / HumanConstant.MATURE_TIME;
        }
        if (mature > HumanConstant.MATURE * HumanConstant.MATURE_TIME) {
            return -(mature - HumanConstant.MATURE * HumanConstant.MATURE_TIME) / HumanConstant.MATURE;
        }
        return 0;
    }

    public boolean isDead() {
        if (getNumerology() > HumanConstant.MAX_NUMEROLOGY) {
            int res = RollDice.rollDices(20, 1);
            if (res == 1) {
                return true;
            }
        }
        return false;
    }
}
